Summary: Valgrind Memory Debugger
Name: valgrind
Version: 3.0.0.SVN
Release: 1
Copyright: GPL
Group: Development/Debuggers
Packager: Jeremy Fitzhardinge <jeremy@goop.org>
Source: valgrind-3.0.0.SVN.tar.bz2

Buildroot: %{_tmppath}/valgrind

%description 

Valgrind is a GPL'd system for debugging and profiling x86-Linux programs.
With the tools that come with Valgrind, you can automatically detect
many memory management and threading bugs, avoiding hours of frustrating
bug-hunting, making your programs more stable. You can also perform
detailed profiling to help speed up your programs.

The Valgrind distribution includes five tools: two memory error
detectors, a thread error detector, a cache profiler and a heap profiler.
Several other tools have been built with Valgrind.

%prep
%setup -n valgrind-3.0.0.SVN

%build
./configure --prefix=/usr
make

%install
make install DESTDIR=$RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/usr/include/valgrind/valgrind.h
/usr/include/valgrind/memcheck.h
#/usr/include/valgrind/helgrind.h
/usr/include/valgrind/basic_types.h
/usr/include/valgrind/tool.h
/usr/include/valgrind/tool_asm.h
/usr/include/valgrind/amd64/tool_arch.h
/usr/include/valgrind/arm/tool_arch.h
/usr/include/valgrind/x86/tool_arch.h
/usr/include/valgrind/linux/vki.h
/usr/include/valgrind/amd64-linux/vki_arch.h
/usr/include/valgrind/amd64-linux/vki_arch_posixtypes.h
/usr/include/valgrind/arm-linux/vki_arch.h
/usr/include/valgrind/arm-linux/vki_arch_posixtypes.h
/usr/include/valgrind/x86-linux/vki_arch.h
/usr/include/valgrind/x86-linux/vki_arch_posixtypes.h
/usr/bin/valgrind
/usr/bin/cg_annotate
/usr/bin/valgrind-listener
/usr/lib/valgrind
/usr/lib/pkgconfig/valgrind.pc

%doc
/usr/share/doc/valgrind/*

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
